#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <deque>

using namespace std;

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    string s;
    cin >> s;
    vector<int> cnt(26), needed(26), current(26);
    for (const auto& c : s) ++cnt[c - 'a'];
    int d = 0;
    for (int i = 0; i < 26; ++i) {
        if (cnt[i] > 0) {
            if (d == 0) d = cnt[i];
            else d = gcd(d, cnt[i]);
        }
    }
    for (int curr = d; curr >= 0; --curr) {
        if (d % curr != 0) continue;
        int sm = 0;
        needed.assign(26, 0), current.assign(26, 0);
        for (int i = 0; i < 26; ++i) sm += (needed[i] = cnt[i] / curr);
        int cs = 0;
        bool good = true;
        int done = 0;
        for (const auto& c : s) {
            int ch = c - 'a';
            ++cs;
            ++current[ch];
            if (current[ch] > (done + 1) * needed[ch]) {
                good = false;
                break;
            } else if (cs == sm) {
                cs = 0;
                ++done;
            }
        }
        if (good) {
            cout << curr << "\n";
            return 0;
        }
    }
    return 0;
}

