#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 5 * 1000 * 1000 + 228;

int n;
int cnt[27];
int ptr[27];
ll cost[2] = {1, 10 * 1000 * 1000};
ll suf_cnt[MAX_N][13];
char st[MAX_N];

bool check(int sz)
{
	for (int i = sz + sz; i <= n; i += sz)
	{
		for (int j = 0; j < 13; ++j) 
		{
			if (suf_cnt[i][j] - suf_cnt[i - sz][j] != suf_cnt[sz][j]) return false;
		}
	}
	
	return true;
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif

	scanf("%s", st);
	
	for (int i = 0; i < 13; ++i)
	{
		for (int j = 0; j < 2; ++j)
		{
			cnt[2 * i + j] = cost[j];
			ptr[2 * i + j] = i;
		}
	}

	n = 1;
	for (char *it = st; *it != '\0'; ++it, ++n)
	{
		memcpy(suf_cnt[n], suf_cnt[n - 1], sizeof(ll) * 13);
		suf_cnt[n][ptr[*it - 'a']] += cnt[*it - 'a'];
	}
	--n;
	
	for (int i = 1; i <= n; ++i)
	{
		if (n % i == 0 && check(i)) return 0 * printf("%d\n", n / i);
	}

	return 0;
}

