#include <bits/stdc++.h>

using namespace std;

string s;
vector<int> cnt[26];

bool check(int n) {
	if (s.size() % n) return false;
	vector<int> fp(26);
	for (int i = 0; i < 26; ++i) {
		for (int j = n; j < s.size(); j += n) {
			if (cnt[i][j+n] - cnt[i][j] != cnt[i][j] - cnt[i][j-n]) return false;
		}
	}
	return true;
}

int gcd(int a, int b) {
	return b ? gcd(b, a % b) : a;
}

int main() {
	cin >> s;
	vector<int> cnts(26);
	for (int i = 0; i < s.size(); ++i) {
		cnts[s[i]-'a']++;
	}
	int g = 0;
	for (int i = 0; i < 26; ++i) {
		g = gcd(g, cnts[i]);
	}

	for (int i = 0; i < 26; ++i) {
		cnt[i].resize(s.size()+1);
		for (int j = 0; j < s.size(); ++j) {
			cnt[i][j+1] = cnt[i][j] + static_cast<bool>(s[j] - 'a' == i);
		}
	}

	for (int i = 1; ; ++i) {
		if ((s.size() % i == 0) && (g % (s.size()/i) == 0) && check(i)) {
			cout << s.size()/i << endl;
			break;
		}
	}
}
