#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 5 * 1000 * 1000 + 228;

int gcd(int a, int b)
{
	return b ? gcd(b, a % b) : a;
}

int n;
int cnt[27];
int ptr[27];
int go_to[27];
int ptr_to[27];
int cnt_to[27];
bool used[27];
int cc[27];
ll cost[2] = {1, 10 * 1000 * 1000};
ll suf_cnt[MAX_N / 2][13];
char st[MAX_N];
int go_sz = 0;
ll need[13];

bool check(int sz)
{
	--sz;
	memcpy(need, suf_cnt[sz >> 1], sizeof(ll) * go_sz);

	if ((sz & 1)) need[ptr_to[(int)st[sz]]] += cnt_to[(int)st[sz]];
	
	++sz;
	for (int i = sz + sz - 1; i < n; i += sz)
	{
		if (i & 1) suf_cnt[i >> 1][ptr_to[(int)st[i]]] += cnt_to[(int)st[i]];
		if ((i - sz) & 1) suf_cnt[(i - sz) >> 1][ptr_to[(int)st[i - sz]]] += cnt_to[(int)st[i - sz]];
		
		bool ok = true;
		for (int j = 0; j < go_sz && ok; ++j) 
		{
			if (suf_cnt[i >> 1][j] - suf_cnt[(i - sz) >> 1][j] != need[j]) ok = false;
		}

		if (i & 1) suf_cnt[i >> 1][ptr_to[(int)st[i]]] -= cnt_to[(int)st[i]];
		if ((i - sz) & 1) suf_cnt[(i - sz) >> 1][ptr_to[(int)st[i - sz]]] -= cnt_to[(int)st[i - sz]];

		if (!ok) return false;
	}
	
	return true;
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif

	scanf("%s", st);
	
	for (int i = 0; i < 13; ++i)
	{
		for (int j = 0; j < 2; ++j)
		{
			cnt[2 * i + j] = cost[j];
			ptr[2 * i + j] = i;
		}
	}
	
	n = 1;
	for (char *it = st; *it != '\0'; ++it, ++n)
	{
		used[(int)(*it -= 'a')] = true;
		++cc[(int)*it];
	}
	--n;
	
	int gc = cc[0];
	for (int i = 1; i < 26; ++i) gc = gcd(gc, cc[i]);

	int ptr1 = 0;
	for (int i = 0; i < 26; ++i)
	{
		if (used[i])
		{
			go_to[i] = ptr1++;
			ptr_to[i] = ptr[go_to[i]];
			cnt_to[i] = cnt[go_to[i]];
		}
	}
	
	if (ptr1 == 1) return 0 * printf("%d\n", n);
	go_sz = (ptr1 + 1) / 2;

	int ff = 2;
	suf_cnt[0][ptr_to[(int)st[0]]] = cnt_to[(int)st[0]];
	for (char *it = st + 2; ff <= n; ff += 2, it += 2)
	{
		memcpy(suf_cnt[ff >> 1], suf_cnt[(ff >> 1) - 1], sizeof(ll) * go_sz);
		suf_cnt[ff >> 1][ptr_to[(int)(*it)]] += cnt_to[(int)(*it)];
		suf_cnt[ff >> 1][ptr_to[(int)(*(it - 1))]] += cnt_to[(int)(*(it - 1))];
	}
	
	for (int i = 1; i <= n; ++i)
	{
		if (n % i == 0 && gc % (n / i) == 0 && check(i)) return 0 * printf("%d\n", n / i);
	}

	return 0;
}

