#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 5 * 1000 * 1000 + 228;

int gcd(int a, int b)
{
	return b ? gcd(b, a % b) : a;
}

int n;
int go_to[27];
bool used[27];
int cc[27];
int suf_cnt[MAX_N / 2][26];
char st[MAX_N];
int go_sz = 0;
int need[26];

bool check(int sz)
{
	--sz;
	memcpy(need, suf_cnt[sz >> 1], sizeof(int) * go_sz);

	if ((sz & 1)) ++need[(int)st[sz]];
	
	++sz;
	for (int i = sz + sz - 1; i < n; i += sz)
	{
		if (i & 1) ++suf_cnt[i >> 1][(int)st[i]];
		if ((i - sz) & 1) ++suf_cnt[(i - sz) >> 1][(int)st[i - sz]];
		
		bool ok = true;
		for (int j = 0; j < go_sz && ok; ++j) 
		{
			if (suf_cnt[i >> 1][j] - suf_cnt[(i - sz) >> 1][j] != need[j]) ok = false;
		}

		if (i & 1) --suf_cnt[i >> 1][(int)st[i]];
		if ((i - sz) & 1) --suf_cnt[(i - sz) >> 1][(int)st[i - sz]];
		
		if (!ok) return false;
	}
	
	return true;
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif

	scanf("%s", st);
	
	n = 1;
	for (char *it = st; *it != '\0'; ++it, ++n)
	{
		used[(int)(*it -= 'a')] = true;
		++cc[(int)*it];
	}
	--n;
	
	int gc = cc[0];
	for (int i = 1; i < 26; ++i) gc = gcd(gc, cc[i]);

	int ptr1 = 0;
	for (int i = 0; i < 26; ++i)
	{
		if (used[i]) go_to[i] = ptr1++;
	}
	
	if (ptr1 == 1) return 0 * printf("%d\n", n);
	go_sz = ptr1;

	int ff = 2;
	suf_cnt[0][go_to[(int)st[0]]] = 1;
	for (char *it = st + 2; ff <= n; ff += 2, it += 2)
	{
		*it = go_to[(int)*it];
		*(it - 1) = go_to[(int)(*(it - 1))];
		memcpy(suf_cnt[ff >> 1], suf_cnt[(ff >> 1) - 1], sizeof(int) * go_sz);
		++suf_cnt[ff >> 1][(int)(*it)];
		++suf_cnt[ff >> 1][(int)(*(it - 1))];
	}
	
	st[0] = go_to[(int)st[0]];
	if (n & 1) st[n - 1] = go_to[(int)st[n - 1]];
	
	for (int i = 1; i <= n; ++i)
	{
		if (n % i == 0 && gc % (n / i) == 0 && check(i)) return 0 * printf("%d\n", n / i);
	}

	return 0;
}

