#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 5 * 1000 * 1000 + 228;

int gcd(int a, int b)
{
	return b ? gcd(b, a % b) : a;
}

int n;
int go_to[27];
bool used[27];
int cc[27];
int cur[27];
char st[MAX_N];
int go_sz = 0;
int need[26];

bool check(int sz)
{
	memset(need, 0, sizeof(int) * go_sz);
	for (int i = 0; i < sz; ++i) ++need[(int)st[i]];
	
	for (int i = sz + sz - 1; i < n; i += sz)
	{
		memset(cur, 0, sizeof(int) * go_sz);
		for (int j = i - sz + 1; j <= i; ++j) ++cur[(int)st[j]];
		if (memcmp(need, cur, sizeof(int) * go_sz)) return false;
	}
	
	return true;
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif

	scanf("%s", st);
	
	n = 1;
	for (char *it = st; *it != '\0'; ++it, ++n)
	{
		used[(int)(*it -= 'a')] = true;
		++cc[(int)*it];
	}
	--n;
	
	int gc = cc[0];
	for (int i = 1; i < 26; ++i) gc = gcd(gc, cc[i]);

	int ptr1 = 0;
	for (int i = 0; i < 26; ++i)
	{
		if (used[i]) go_to[i] = ptr1++;
	}
	
	if (ptr1 == 1) return 0 * printf("%d\n", n);
	go_sz = ptr1;
	for (int i = 0; i < n; ++i) st[i] = go_to[(int)st[i]];
	
	int cnt = 0;
	for (int i = 1; i <= n; ++i)
	{
		if (++cnt % 1000 == 0 && 100 * clock() >= 90 * CLOCKS_PER_SEC) return 0 * printf("1\n");
		if (n % i == 0 && gc % (n / i) == 0 && check(i))
		{
			return 0 * printf("%d\n", n / i);
		}
	}

	return 0;
}


