#include <cassert>
#include <cinttypes>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
#include <string.h>
#include <algorithm>
#include <cmath>
#include <cstdio>

typedef int8_t i8;
typedef int16_t i16;
typedef uint8_t ui8;
typedef uint16_t ui16;
typedef uint32_t ui32;
typedef int32_t i32;
typedef uint64_t ui64;
typedef int64_t i64;

constexpr ui64 INF = 1e18;

constexpr int alpabet_number = 26;

char str[5000001];
ui64 pr[5000001];
std::vector<int> alp(alpabet_number);
ui64 my_alp = 0;
ui64 bad = 0;

void solve(int from, int to) {
    bad = pr[to - 1] - (from ? pr[from - 1] : 0);
}

int main(void) {
    scanf("%s", str);
    int n = strlen(str);
    for (int i = 0; i < n; ++i) {
        alp[str[i] - 'a']++;
        ui64 c = str[i] - 'a' + 1372;
        pr[i] = c * c * c * c * c;
        if (i) {
            pr[i] += pr[i - 1];
        }
        // std::cout << pr[i] << std::endl;
    }
    std::vector<int> div;
    for (int i = 1; i * i <= n; ++i) {
        if (n % i == 0) {
            div.push_back(n / i);
            div.push_back(i);
        }
    }

    std::sort(div.rbegin(), div.rend());
    int ans = 1;
    for (auto& divisor : div) {
        auto len = n / divisor;
        // std::cout << n << " " << divisor << std::endl;
        // std::cout << c << std::endl;

        int f = 0;
        my_alp = 0;
        for (int i = 0; i < alpabet_number; ++i) {
            ui64 c1 = ui64(i + 1372);
            if (alp[i] % divisor != 0) {
                f = 1;
                break;
            }
            my_alp += ui64(alp[i] / divisor) * c1 * c1 * c1 * c1 * c1;
        }
        if (f)
            continue;
        for (int i = 0; i < n; i += len) {
            solve(i, i + len);
            // std::cout << my_alp << std::endl;
            // std::cout << bad << std::endl;
            if (my_alp != bad) {
                f = 1;
                break;
            }
        }
        if (!f) {
            printf("%d\n", divisor);
            return 0;
        }
    }
    assert(false);
    printf("%d\n", ans);
    return 0;
}
